ArenaHistory.PlayerSpec = {}
local PlayerSpec = ArenaHistory.PlayerSpec
local Logger = ArenaHistory.Logger

PlayerSpec.logger = Logger.new("PlayerSpec")
PlayerSpec.localizedNameToId = nil

function PlayerSpec:init()
  self.logger:debug("init")
  PlayerSpec.localizedNameToId = {}
  for id = 1, 500 do
    local id, localizedName, description, icon, background, role, class =
        GetSpecializationInfoByID(id)
    if id ~= nil and class ~= nil and localizedName ~= nil then
      self.localizedNameToId[class .. "_" .. localizedName] = id
    end
  end
end

function PlayerSpec:getSpecIdFromLocalizedName(class, name)
  if self.localizedNameToId == nil then
    self:init()
  end
  if class ~= nil and name ~= nil then
    return self.localizedNameToId[class .. "_" .. name]
  else
    return nil
  end
end
