ArenaHistory.ShareGameDialog = {}
local ShareGameDialog = ArenaHistory.ShareGameDialog
local ArenaMatch = ArenaHistory.ArenaMatch
local BASE64 = LibStub:GetLibrary("base64")

local UPLOAD_URL_PREFIX = "https://arena-history.appspot.com/game/upload?data="

ShareGameDialog.logger = ArenaHistory.Logger.new("ShareGameDialog")
ShareGameDialog.frame = ArenaHistory_ShareGameDialog
ShareGameDialog.editBox = ArenaHistory_ShareGameDialog_EditBox

function ShareGameDialog.createShareButton(game, parent)
  local button = CreateFrame("Button", nil, parent, "UIPanelButtonTemplate")
  button:SetText("Share")
  button:SetScript("OnClick", function()
    ShareGameDialog:show(game)
  end)
  return button
end

function ShareGameDialog:show(game)
  local pb = ArenaMatch.copy(game, true):Serialize()
  local url = UPLOAD_URL_PREFIX .. BASE64.enc(pb)
  local editBox = self.editBox
  local handler = function()
    editBox:SetText(url)
    editBox:HighlightText()
    editBox:SetFocus(true)
    editBox:SetCursorPosition(0)
  end
  editBox:SetAutoFocus(true)
  handler()

  editBox:SetScript("OnChar", handler)
  editBox:SetScript("OnMouseDown", handler)
  editBox:SetScript("OnEnter", handler)
  editBox:SetScript("OnCursorChanged", handler)

  self.frame:Raise()
  self.frame:Show()
end

function ShareGameDialog:hide()
  self.frame:Hide()
end
